// Copyright 2017 by Yun Xiang, Tam Chantem, and Robert Dick.
// All rights reserved.

/*Copyright 2010, Yun Xiang<xiangyun@umich.edu>.*/
#include "RStd.h"
#include "RString.h"
#include "Stats.h"
#include "Mttf.h"
#include "Cont.h"
#include "Parse.h"

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <cmath>
#include <limits>
#include <algorithm>
#include <fstream>
#include <assert.h>
#include <ctime>
#include <cstdlib>
#ifndef XY_VER
//#include "timer.h"
#endif
using namespace std;
using namespace rstd;


/*###########################################################################*/

/*===========================================================================*/


void //name changed here, update h file!!!!!!!!!   
PE::age_update() {  
  RVector<double> t_scale;
  RVector<double> v_scale;
  RVector<double> f_scale;
  
  for (int i = 0; i < temp.size(); i++)
    {
      t_scale.push_back((temp[i] + 273.0)/(ref_tmp() + 273));
      v_scale.push_back(vol[i]/ref_vol());
      f_scale.push_back(freq[i]/ref_feq());
    }  
  mttf(v_scale, t_scale, f_scale);	
  return;
}

//reloaded function
void
PE::age_update(double time_limit) {  
  RVector<double> t_scale;
  RVector<double> v_scale;
  RVector<double> f_scale;

  for (int i=0; i<temp.size();i++)
    {
      t_scale.push_back((temp[i] + 273.0)/(ref_tmp() + 273));
      v_scale.push_back(vol[i]/ref_vol());
      f_scale.push_back(freq[i]/ref_feq());
    }  

  mttf(v_scale, t_scale, f_scale);
  em_age = em_age + em_increase;
  tc_age = tc_age + tc_increase;
  sm_age = sm_age + sm_increase;
  tddb_age = tddb_age + tddb_increase;
  age = 1-(1-em_age) * (1-tc_age) * (1-sm_age) * (1-tddb_age);		
  return;
}
/*===========================================================================*/
// separate calculation of the 4 different types

void
PE::em_mttf(const RVector<double> &v_scale, const RVector<double> &t_scale, const RVector<double> &f_scale) {
  
  double mttf;
  double coef_aem =
    (ref_em()/exp(EM_Ea/(Boltzmann*(ref_tmp()+273))))*pow(ref_vol()*ref_feq(),EM_n);
  
  for (int i = 0; i < t_scale.size(); i++)
    {
      mttf =  ((coef_aem/pow(v_scale[i]*ref_vol()*f_scale[i]*ref_feq(),EM_n))
	       *exp(EM_Ea/(Boltzmann*(ref_tmp()+273)*t_scale[i])));
      em_mu.push_back(mttf/rstd::gamma_(1+(1/em_sigma))); 
    }
  return;
} 

/*===========================================================================*/


void
PE::flow_profile( RVector<double> &local_temp) {
  RVector<double> processed_temp;
  //* delete all the equal values
  processed_temp.push_back(temp[0]);
  if (temp.size() > 1){
    for (int i = 1; i < temp.size(); i++) {
      if (temp[i]!= temp[i-1])
	processed_temp.push_back(temp[i]);
    }
  }
  if (processed_temp.size()>1){
    if (processed_temp[processed_temp.size()-1] == processed_temp[0]){
      processed_temp.pop_back();
    }
  }
  //* find local_max and local min

  local_temp.push_back(processed_temp[0]);

  if (processed_temp.size() > 1){
    for (int i = 1; i < processed_temp.size()-1; i++ )
      {	
				int j,k;
	  		j = i-1;
	  		k = i+1; 				
				if ((processed_temp[i] < processed_temp[j])&&(processed_temp[i] < processed_temp[k])){
	  			local_temp.push_back(processed_temp[i]);
				}
				if ((processed_temp[i] > processed_temp[j])&&(processed_temp[i] > processed_temp[k])){
	  			local_temp.push_back(processed_temp[i]);
				}	  
     }
  }
  local_temp.push_back(processed_temp[processed_temp.size()-1]);	
  return;
}

/*===========================================================================*/
//Rhychilik's
void
PE::RFC(const RVector<double> &local_temp) {
	//cout<<"start RFC2 with size: "<<local_temp.size()<<endl;
	//cout<<"start RFC2 with: "<<local_temp<<endl;
  Cycle tmp;
	full_cycles.clear();
	half_cycles.clear();

	if (local_temp[0] > local_temp[1]){
		double MAX_right = 0;
		for (int j = 1; j < local_temp.size(); j++){
			if (local_temp[0]<=local_temp[j])
				break;
			else {
				double a = local_temp[0] - local_temp[j];
				if (a > MAX_right)
					MAX_right = a;											
			}//else
		}//for(int j
		tmp.peak = local_temp[0];
		tmp.swing = MAX_right;
		tmp.index = 0;	
		full_cycles.push_back(tmp);
	}

	for (int i = 1; i < local_temp.size()-1; i++)
	{
		double MAX_left = 0, MAX_right = 0;
		int j;

		if(local_temp[i] > local_temp[i+1])//it is peak
		{
			//do what? find max and min
			for (j = i - 1; j >= 0; j--){
				if (local_temp[i]<=local_temp[j])
					break;
				else {
					double a = local_temp[i] - local_temp[j];
					if (a > MAX_left)
						MAX_left = a;											
				}//else
			}//for(int j
			for (j = i+1; j < local_temp.size(); j++){
				if (local_temp[i]<=local_temp[j])
					break;
				else {
					double a = local_temp[i] - local_temp[j];
					if (a > MAX_right)
						MAX_right = a;											
				}//else
			}//for(int j
		
			tmp.peak = local_temp[i];
			tmp.index = i;	

			if (MAX_left >= MAX_right){
				tmp.swing = MAX_right;
				if ((j>local_temp.size()-1)&&(local_temp[local_temp.size()-1] < local_temp[i]))
					half_cycles.push_back(tmp);
				else 
					full_cycles.push_back(tmp);
			}	
			else {
				tmp.swing = MAX_left;			
				full_cycles.push_back(tmp);
			}				
		}	// if(local
	}//for(int i


	if (local_temp[local_temp.size()-1] > local_temp[local_temp.size()-2]){
		double MAX_left = 0;
		for (int j = local_temp.size()-2; j >= 0; j--){
			if (local_temp[local_temp.size()-1]<=local_temp[j])
				break;
			else {
				double a = local_temp[local_temp.size()-1] - local_temp[j];
				if (a > MAX_left)
					MAX_left = a;											
			}//else
		}//for(int j
		tmp.peak = local_temp[local_temp.size()-1];
		tmp.swing = MAX_left;
		tmp.index = local_temp.size()-1;	
		half_cycles.push_back(tmp);
	}
	cout<<"The full cycles are: ";
	for (int i = 0; i < full_cycles.size(); i++){
	  cout << full_cycles[i].swing << endl;
	  //if (full_cycles[i].swing > 20)
	  //cout<<"  "<<full_cycles[i].swing;
	}
	cout<<endl;

	cout<<"The full cycles peaks are: ";
	for (int i = 0; i < full_cycles.size(); i++){
		if (full_cycles[i].swing > 20)
			cout<<"  "<<full_cycles[i].peak;
	}
	cout<<endl;

	cout<<"The half cycles are: ";
	for (int i = 0; i < half_cycles.size(); i++){
		cout<<"  "<<half_cycles[i].swing;
	}
	cout<<endl;

	cout<<"The half cycles peaks are: ";
	for (int i = 0; i < half_cycles.size(); i++){
		cout<<"  "<<half_cycles[i].peak;
	}
	cout<<endl;

	return;
}



/*===========================================================================*/
void
PE::flow_profile() {
  RVector<double> processed_temp;
    //* delete all the equal values
  processed_temp.push_back(temp[0]);
  if (temp.size() > 1){
    for (int i = 1; i < temp.size(); i++) {
      if (temp[i]!= temp[i-1])
				processed_temp.push_back(temp[i]);
    }
  }
  if (processed_temp.size()>1){
    if (processed_temp[processed_temp.size()-1] == processed_temp[0]){
      processed_temp.pop_back();
    }
  }
  //* find local_max and local min
  RVector<double> local_temp;
  if (processed_temp.size()==1){
    local_temp.push_back(processed_temp[0]);
  }
  else{
    for (int i = 0; i < processed_temp.size(); i++ )
      {	
				int j,k;
				int length = processed_temp.size();
				if (i == 0){
	  			j = processed_temp.size()-1;
	  			k = i+1;
				}
				else if ( i == length-1){
	  			j = i-1;
	  			k = 0;  
				}
				else{
	  			j = i-1;
	  			k = i+1; 
				}

				if ((processed_temp[i] < processed_temp[j]) && (processed_temp[i] < processed_temp[k])){
	  			local_temp.push_back(processed_temp[i]);
				}
				if ((processed_temp[i] > processed_temp[j]) && (processed_temp[i] > processed_temp[k])){
	  			local_temp.push_back(processed_temp[i]);
				}	  
      }
  }
  // reprocessing so that peak is at the head
  int max_indx = max(local_temp);
  peak.push_back(local_temp[max_indx]);
  for (int i = max_indx+1; i < local_temp.size(); i++){
    if (local_temp[i] < local_temp[i-1])
      valley.push_back(local_temp[i]);
    else peak.push_back(local_temp[i]);
  }
  for (int i = 0; i < max_indx; i++){
    if (local_temp[i] < local_temp[i+1])
      valley.push_back(local_temp[i]);
    else peak.push_back(local_temp[i]);
  }
  peak.push_back(local_temp[max_indx]);
  return;
}

/*===========================================================================*/
//Downings
void
PE::RFC() {
  RVector<double> peak_0;
  RVector<double> valley_0;
  peak_0 = *peak.clone();
  valley_0 = *valley.clone();

	if (cycles.size() != 0){
		return;
	}

  if (valley.size() == 0){
    return;
  }
  Cycle tmp;
  RVector<int> index;
  for (int k = 0; k < peak.size(); k++) {
    index.push_back(k);
  }
  RVector<double>::iterator pos_0, pos_1;
  RVector<int>::iterator pos_2;
  pos_0 = peak_0.begin();
  pos_1 = valley_0.begin();
  pos_2 = index.begin();
  int i = 0;
  while (peak_0.size() > 2)
    {
      //cout<<"processing the: "<<i<<"th peak with index: "<<index[i]<<endl;
      //case: peak-valley-peak
      if ((peak_0[i] - valley_0[i]) <= (peak_0[i+1]-valley_0[i])){
				tmp.peak = peak_0[i];
				tmp.swing = peak_0[i] - valley_0[i];
				tmp.index = index[i];
				cycles.push_back(tmp);
				peak_0.erase(pos_0+i);
				valley_0.erase(pos_1+i);
				index.erase(pos_2+i);
				if (i > 0)
	  			i = i-2;	
				else
	  			i = i-1;
      }
      //case: valley-peak-valley
      else if ((peak_0[i+1] - valley_0[i]) <= (peak_0[i+1]-valley_0[i+1])){
				tmp.peak = peak_0[i+1];
				tmp.swing = peak_0[i+1] - valley_0[i];
				tmp.index = index[i+1];
				cycles.push_back(tmp);
				peak_0.erase(pos_0+i+1);
				valley_0.erase(pos_1+i);
				index.erase(pos_2+i+1);
				i--;
      }
      i++;
    }
  if(valley_0.size() > 0){
    tmp.peak = peak_0[0];
    tmp.swing = peak_0[0] - valley_0[0];
    tmp.index = 0;
    cycles.push_back(tmp);
  }
  return;
}


/*===========================================================================*/
void
PE::tc_mttf(const RVector<double> & tmp) {
	tc_mu.clear();
  flow_profile();
  RFC();
#ifdef XY_DEBUG
	cout<<"The cycles are: ";
	for (int i = 0; i < cycles.size(); i++){
		if (cycles[i].swing > 20.0)
			cout<<"  "<<cycles[i].swing;
	}
	cout << endl;
	cout<<"The peaks are: ";
	for (int i = 0; i < cycles.size(); i++){
		if (cycles[i].swing > 20.0)
			cout<<"  "<<cycles[i].peak;
	}
	cout << endl;
#endif

  double N_ref = pow((REF_TDIFF - TC_thresh),-TC_B*1.0)*exp(TC_Ea/(Boltzmann*(REF_TMAX + 273.0)));
  RVector<double> mttf_0;
  for (int i = 0; i < cycles.size(); i++){
    if (cycles[i].swing > TC_thresh){//larger than elastic
      double N = pow((cycles[i].swing - TC_thresh),-TC_B*1.0)*exp(TC_Ea/(Boltzmann * (cycles[i].peak + 273.0)));
      mttf_0.push_back(N_ref/N);// 1/(N/N_ref)
    }
  }

  if (mttf_0.size() > 0){
    double N_final = sum(mttf_0);
    double a = sum(time)*ref_tc()*1e-5/(N_final);//TC adjustment, will change later
    tc_mu.push_back(a/rstd::gamma_(1 + (1/tc_sigma)));
  }
  else{
    tc_mu.push_back(INF);
  }
  return;
}

/*===========================================================================*/
void
PE::tc_mttf() {
	tc_mu.clear();
	RVector<double> local_temp;
  flow_profile(local_temp);
  RFC(local_temp);
  double N_ref = pow((REF_TDIFF - TC_thresh),-TC_B*1.0)*exp(TC_Ea/(Boltzmann * (REF_TMAX + 273.0)));
  RVector<double> mttf_0;
  for (int i = 0; i < full_cycles.size(); i++){
    if (full_cycles[i].swing > TC_thresh){//larger than elastic
      double N = pow((full_cycles[i].swing - TC_thresh),-TC_B*1.0)*exp(TC_Ea/(Boltzmann* (full_cycles[i].peak + 273.0)));
      mttf_0.push_back(N_ref/N);// 1/(N/N_ref)
    }
  }
  if (mttf_0.size()>0){
    double N_final = sum(mttf_0);
    double a = sum(time)*ref_tc()*1e-5/(N_final);//TC adjustment, will change later
    tc_mu.push_back(a/rstd::gamma_(1 + (1/tc_sigma)));
  }
  else{
    tc_mu.push_back(INF);
  }
  return;
}

/*===========================================================================*/
void
PE::sm_mttf(const RVector<double> & t_scale) {
  double mttf_0;
  double coef_asm = ref_sm()*pow(fabs(SM_t0 - ref_tmp()), SM_n)/exp(SM_Ea/(Boltzmann*(ref_tmp()+273.0)));
  for (int i = 0; i < time.size(); i++){
    mttf_0 = coef_asm * pow(fabs((273+SM_t0)-(ref_tmp()+273)*t_scale[i]), -SM_n) * exp(SM_Ea/(Boltzmann*(ref_tmp()+273.0)*t_scale[i]));
    sm_mu.push_back(mttf_0/rstd::gamma_(1+(1/sm_sigma)));
  } 
  return;
}

/*===========================================================================*/
void
PE::tddb_mttf(const RVector<double> & v_scale, const RVector<double> & t_scale) {
  double mttf_0;
  double coef_tddb = ref_tddb()*pow(ref_vol(),TDDB_a-TDDB_b*(ref_tmp()+273.0))*
    exp((-TDDB_A-TDDB_B/(ref_tmp()+273.0)-TDDB_C*(ref_tmp()+273.0))/(Boltzmann*(ref_tmp()+273.0)));
  for (int i = 0; i < time.size(); i++){
    mttf_0 = coef_tddb*pow(ref_vol()*v_scale[i], -TDDB_a+TDDB_b*(ref_tmp()+273.0)*t_scale[i])*
      exp((TDDB_A+TDDB_B/((ref_tmp()+273.0)*t_scale[i])+TDDB_C*(ref_tmp()+273.0)*t_scale[i])/(Boltzmann*(ref_tmp()+273.0)*t_scale[i]));
    tddb_mu.push_back(mttf_0/rstd::gamma_(1+(1/tddb_sigma)));
  }
  return;
}


/*===========================================================================*/
void
PE::mttf(const RVector<double> & v_scale, const RVector<double> & t_scale, const
RVector<double> & f_scale) {

	em_mttf(v_scale, t_scale, f_scale);
	//following is using Rhychilik's algorithm
	//tc_mttf();
	//following is using Downing's algorithm
	tc_mttf(temp);
	sm_mttf(t_scale);
	tddb_mttf(v_scale, t_scale);

	for (int i = 0; i < time.size(); i++){
	  total_em += time[i] / em_mu[i];
	  total_sm += time[i] / sm_mu[i];
	  total_tc += time[i] / tc_mu[0];//this is 0 because it has only 1 entry in TC profile. Just for consistence
	  total_tddb += time[i]/tddb_mu[i];	  
	}

	//get equivalent eta
	double a = sum(time);
	total_em = a/total_em;
	total_sm = a/total_sm;
	total_tc = a/total_tc;
	total_tddb = a/total_tddb;
	return;
}
/*===========================================================================*/
void
PE::reload(const RVector<double> & rtime, const RVector<double> & rtemp, const RVector<double> & rvol, const RVector<double> & rfreq, const RVector<Cycle> & rcycle){
  temp.clear();
  temp = rtemp;
  time.clear();
  time = rtime;
  vol.clear();
  vol = rvol;
  freq.clear();
  freq = rfreq;
  em_mu.clear();
  sm_mu.clear();
  tc_mu.clear();
  tddb_mu.clear();
  peak.clear();
  valley.clear();
  cycles.clear();	
	cycles = rcycle;
  total_em = 0;
  total_sm = 0;
  total_tc = 0;
  total_tddb = 0;
}

/*===========================================================================*/


int compare (const void * a, const void * b)
{
   double intOne = *((double*)a);
	 double intTwo = *((double*)b);
	 if (intOne < intTwo)
			return -1;
	 if (intOne == intTwo)
			return 0;
	 return 1;
}

/*==================================================================*/



double sys_mttf(const string & rel_file)
{
// rel_file: reliability input file name
    RVector<PE> pe; 
    GLOBAL def;
    RVector<string> survive_list;
    RVector<RVector<RVector<double> > > therm_profile, time_profile, vol_profile, freq_profile;
		RVector<RVector<RVector<Cycle> > > cycle_profile;
		cout<<"start parsing!!"<<endl;
    int a = parse(pe, rel_file.c_str() , survive_list, therm_profile, time_profile, vol_profile, freq_profile, cycle_profile, def);
 		cout<<"end parsing!!"<<endl;
    if (!a) {
      cout << "wrong input format, abort" << endl;
      return 0;
    }
    //cout<<"the cycle profile size is:"<<cycle_profile.size()<<endl;
//Memory reporting!!
		unsigned int memory = 0;
		for (int i = 0; i < therm_profile.size(); i++){//survival list
			for (int j = 0; j < therm_profile[i].size(); j++){//component
				for (int k = 0; k < therm_profile[i][j].size(); k++){//time segments
					memory += sizeof(therm_profile[i][j][k]);	
					memory += sizeof(time_profile[i][j][k]);
					memory += sizeof(vol_profile[i][j][k]);		
					memory += sizeof(freq_profile[i][j][k]);	
				}
			}
		}
//		cout<<"Total memory usage is:"<<memory<<endl; 


#ifdef XY_DEBUG
    cout << "survive list is: "<<survive_list<<" the first charactrer is: " <<
			survive_list[0][0] << endl;
    cout << "size of pe is: " << pe.size() << endl;
#endif
#ifndef XY_VER
  //timer t;
  //t.start();
#endif
  RVector<RVector<RVector<double> > > mu_profile;
  //t_profile[i] 0 em, 1 sm, 2 tc, 3 tddb
  // need to reassign SIGMA in PE MTTF calculation
	RVector<RVector<RVector<double> > > mttf_table;
  for (int i = 0; i < survive_list.size(); i++) {
    mu_profile.resize(i+1);
    for (int j = 0; j < pe.size(); j++){
      pe[j].reload(time_profile[i][j], therm_profile[i][j], vol_profile[i][j], freq_profile[i][j], cycle_profile[i][j]);
#ifdef XY_DEBUG
			cout<<"For survive list: "<<survive_list[i]<<" component: "<<j<<" cycles are: "<<endl;
#endif
      pe[j].age_update();
      mu_profile[i].resize(j+1);
      RVector<double> a;
      a.push_back(pe[j].total_em);
      a.push_back(pe[j].total_sm);
      a.push_back(pe[j].total_tc);
      a.push_back(pe[j].total_tddb);
      mu_profile[i][j] = a;
#ifdef XY_DEBUG
			cout<<"for the survive list: "<<survive_list[i]<<" pe: "<<j<<" the component MTTF for em is: "<<a[0]*gamma_(1+1/(pe[j].em_sigma))<<" device MTTF for sm is: "<<a[1]*gamma_(1+1/(pe[j].sm_sigma))<<" TC is: "<<a[2]*gamma_(1+1/(pe[j].tc_sigma))<<" TDDB is: "<<a[3]*gamma_(1+1/(pe[j].tddb_sigma))<<endl;	
#endif
    }
  }
  
  //cout<<"mu table is: "<<mu_profile<<endl;
	  
  //cout << "Thermal profile size: " << therm_profile.size() << endl;

#ifdef DEBUG
   RVector<double> eta1,  beta1,  eta2, beta2;
  for (int i=0; i<pe.size(); i++){
    eta1.push_back(5);
    eta1.push_back(5);
    eta1.push_back(5);
    eta1.push_back(5);
    eta2.push_back(0);
    eta2.push_back(0.5);
    eta2.push_back(0.5);
    eta2.push_back(0.5);
    beta1.push_back(0);
    beta1.push_back(0);
    beta1.push_back(0);
    beta1.push_back(0);
    beta2.push_back(0);
    beta2.push_back(0);
    beta2.push_back(0);
    beta2.push_back(0);
    }
#endif


  int list_index;
  RVector<double> fail_time, fail_order;
 // srand(static_cast<unsigned>(time(0)));
  cout<<"start Monte Carlo simulation"<<endl;
  Monte_Carlo(pe, survive_list, list_index, fail_time, mu_profile, def, fail_order);
  cout<<"Monte Carlo simulation finished"<<endl<<endl;
	//cout.setf(ios::scientific); 
	//cout.precision(5);
	//cout.width(15);
// the last element records the mean time for the first failure
	fail_time.pop_back();
//	qsort (fail_time, fail_time.size(), sizeof(int), compare);
//#ifndef XY_VER


  ofstream myfile;
  myfile.open ("toSort.txt");
	for (int i = 0; i < fail_time.size(); i++){
		myfile << fail_time[i]<<" ";
	}
  myfile.close();

  //cout<<"size of output array is:"<<fail_time.size()<<endl;
//  Quick_sort(0, fail_time.size()-1, fail_time);
//	cout<<fail_time<<endl;
//#endif
  //cout<<"0.5% fail time is:"<<fail_time[5000]<<endl;
  //cout<<"1% fail time is:"<<fail_time[10000]<<endl;
  //cout<<"2% fail time is:"<<fail_time[20000]<<endl;
  //cout<<"5% fail time is:"<<fail_time[50000]<<endl;
  //cout<<"10% fail time is:"<<fail_time[100000]<<endl;
  double MTTF = sum(fail_time)/fail_time.size();
	for (int i = 0; i < fail_time.size(); i++)
		{
			if (fail_time[i] > def.t){
//				double percent = (i*1.0)/(fail_time.size()*1.0);
//				cout<<"the conditonal system failure probability at "<<def.t<<" year is: "<<percent<<endl;
				break;
			}
		}
/*
	cout <<"def.t is: "<<def.t<<"  mu profile is: "<<mu_profile[0][0][0]<<endl;
	long double test_num = wblcdf_PV(0.0020, mu_profile[0][0][0], def.em[0], 0,1);
	cout<<"The age for the above setup is: "<<test_num<<endl;
	if (test_num > 0)
		cout<<"testing number is great than 0"<<endl;
	else 
		cout<<"testing number is exactly 0"<<endl;
*/

	cout << "***********************" << endl;
	for (int i = 0; i < pe.size(); i++){
		int device_number = (def.type[0] == "l")? 1:pe[i].device_num;
		pe[i].em_age = wblcdf_PV(wblinv_PV(pe[i].em_age,mu_profile[0][i][0], def.em[0], 0, device_number)+def.t, mu_profile[0][i][0], def.em[0], 0,device_number);
		device_number = (def.type[1] == "l")? 1:pe[i].device_num;
		pe[i].sm_age = wblcdf_PV(wblinv_PV(pe[i].sm_age,mu_profile[0][i][1], def.sm[0], 0, device_number)+def.t, mu_profile[0][i][1], def.sm[0], 0, device_number);
		device_number = (def.type[2] == "l")? 1:pe[i].device_num;
		pe[i].tc_age = wblcdf_PV(wblinv_PV(pe[i].tc_age,mu_profile[0][i][2], def.tc[0], 0, device_number)+def.t, mu_profile[0][i][2], def.tc[0], 0, device_number);
		device_number = (def.type[3] == "l")? 1:pe[i].device_num;
		pe[i].tddb_age = wblcdf_PV(wblinv_PV(pe[i].tddb_age,mu_profile[0][i][3], def.tddb[0], 0, device_number)+def.t, mu_profile[0][i][3], def.tddb[0], 0, device_number);
		pe[i].age = total_age(pe[i].em_age, pe[i].tc_age, pe[i].sm_age, pe[i].tddb_age);
		cout << "Component " << i << endl;
		cout << "EM Failure Prob: "<<pe[i].em_age << "\t" <<"SM Failure Prob: "<< pe[i].sm_age << "\t" "TC Failure Prob: "<< pe[i].tc_age
		     << "\t" <<"TDDB Failure Prob: " <<pe[i].tddb_age << endl <<"Total Failure Prob: " <<pe[i].age << endl << endl;
		/*
		 		cout<<"After "<<def.t<<" years, for component "<<i<<" em age is: "<<pe[i].em_age<<" sm age is: "<<pe[i].sm_age<<" tc age is: "<<pe[i].tc_age<<" tddb age is: "<<pe[i].tddb_age<<" total age is: "<<pe[i].age<<endl;
		cout << "Total age at " << i << " is " << pe[i].age << endl;
		*/
	}
	
  cout<<"System MTTF is: "<<MTTF<<" years"<<endl;
  //cout<<"the time to 1 percent failure is: "<<fail_time[int(fail_time.size()/100)]<<" years"<<endl;
  //cout << "finished here"<<endl;

#ifndef XY_VER
	//t.stop();
	//cout << "Elapsed Time " << t << endl;
#endif
  return MTTF;
}

/*===========================================================================*/
// print the rank that occurs most frequently
void print_ranking (const RVector<double> &fail_order)
{
// stupid but fast solution here!!
	RVector<double> order;
	order.resize(9999);
	for (int i = 0; i < fail_order.size(); i++){
		order[static_cast<int>(fail_order[i])]++;
	}
	int out = max(order);
	if (out < 1000)
		cout<<"The most frequently happened order is: 0"<<max(order)<<endl;
	else
		cout<<"The most frequently happened order is: "<<max(order)<<endl;	
	return;
} 
/*===========================================================================*/

void PE::aging(double t) {
  double t0;
  if (age!=1){
  t0 = wblinv(age, mu,sigma);
  age += wblintegral(mu, sigma, t0, t0+t);}
	return;
}

/*===========================================================================*/
int min(const RVector<double> & x)
{
  double y = INF*1.0;
  int k = -1;
  for (int i = 0; i < x.size(); i++)
    {
      if ((x[i] <= y)&&(x[i] != 0)){
				y=x[i];
				k=i;
      }
    }

  return k;
}
/*===========================================================================*/
int max(const RVector<double> & x)
{
  double y = 0.0;
  int k = -1;
  for (int i = 0; i < x.size(); i++)
    {
      if ((x[i] > y)&&(x[i] != 0)){
				y=x[i];
				k=i;
      }
    }

  return k;
}
/*===========================================================================*/
double sum(const RVector<double> & x)
{
  double k = 0.0;
  for (int i = 0; i<x.size(); i++)
    k+=x[i];
  return k;
}
/*===========================================================================*/
double new_age(double t, double &mu, double &sigma, double age) {
  double t0,age_0;
  if (age != 1){
    t0 = wblinv(age, mu,sigma);
    age_0 = wblcdf(t0+t,mu, sigma);
    return age_0;
	}
  else 
    return age;
}
/*===========================================================================*/
double total_age(double em_age, double tc_age, double sm_age, double tddb_age)
{
  //return 1-(1-em_age)*(1-sm_age)*(1-tddb_age);
  return 1-(1-em_age)*(1-tc_age)*(1-sm_age)*(1-tddb_age);
}
/*===========================================================================*/
//* Monte-Carlo engine
//*0 em, 1 sm, 2, tc, 3 tddb
void Monte_Carlo(RVector<PE> &pe, const RVector<string> & survive_list, int &list_index, RVector<double> &fail_time, const RVector<RVector<RVector<double> > > & mu, GLOBAL def, RVector<double> &fail_order)
{
  // cout<<"Monte_Carlo starts with mu: "<<mu<<"survive_list: "<<survive_list<<endl;
  RVector<double> init_em, init_tc, init_sm, init_tddb, first_fail;
  for (int i = 0; i < pe.size(); i++)
    {
      init_em.push_back(pe[i].em_age);
      init_sm.push_back(pe[i].sm_age);
      init_tc.push_back(pe[i].tc_age);
      init_tddb.push_back(pe[i].tddb_age);
    }
  for (int trials = 0; trials < MAX_TRIAL; trials++){
    string s_list;
    s_list = survive_list[0];
    RVector<double> age_em, age_tc, age_sm, age_tddb; 
    RVector<double> eta_em, eta_sm, eta_tc, eta_tddb;
    RVector<double> beta_em, beta_sm, beta_tc, beta_tddb;
    for (int i = 0; i < pe.size(); i++)
      {
				pe[i].em_age = init_em[i];
				pe[i].sm_age = init_sm[i];
				pe[i].tc_age = init_tc[i];
				pe[i].tddb_age = init_tddb[i];
				age_em.push_back(unirnd()*(1-init_em[i])+init_em[i]);
				age_sm.push_back(unirnd()*(1-init_sm[i])+init_sm[i]);
				age_tc.push_back(unirnd()*(1-init_tc[i])+init_tc[i]);
				age_tddb.push_back(unirnd()*(1-init_tddb[i])+init_tddb[i]);

				eta_em.push_back(normrnd(def.em[0], def.em[1]));
				eta_sm.push_back(normrnd(def.sm[0], def.sm[1]));
				eta_tc.push_back(normrnd(def.tc[0], def.tc[1]));
				eta_tddb.push_back(normrnd(def.tddb[0], def.tddb[1]));
				beta_em.push_back(normrnd(def.em[2], def.em[3]));
				beta_sm.push_back(normrnd(def.sm[2], def.sm[3]));
				beta_tc.push_back(normrnd(def.tc[2], def.tc[3]));
				beta_tddb.push_back(normrnd(def.tddb[2], def.tddb[3]));	
      }
#ifdef DEBUG
	cout<<"ages are em:"<<age_em<<" sm: "<<age_sm<<" tc: "<<age_tc<<" tddb: "<<age_tddb<<endl;
	cout<<"eta and betas em eta: "<<eta_em<<" sm:"<<eta_sm<<" tc:"<<eta_tc<<" tddb:"<<eta_tddb<<"for beta em: "<<beta_em<<" sm:"<<beta_sm<<" tc:"<<beta_tc<<" tddb:"<<beta_tddb<<endl;
#endif
    double cur_time = 0;
    int cur_index, flag = 1;
    while (in_list(s_list, survive_list, &cur_index)){
      RVector<double> t_em, t_tc, t_sm, t_tddb; 
      for (int i = 0; i < pe.size(); i++){
				if (s_list[i] == '1'){
	  			int device_number;
	  			device_number = (def.type[0] == "l")? 1:pe[i].device_num;
	  			t_em.push_back(wblinv_PV(age_em[i], mu[cur_index][i][0], eta_em[i], beta_em[i], device_number) - wblinv_PV(pe[i].em_age, mu[cur_index][i][0], eta_em[i], beta_em[i], device_number));
	  			device_number = (def.type[1] == "l")? 1:pe[i].device_num;
	  			t_sm.push_back(wblinv_PV(age_sm[i], mu[cur_index][i][1], eta_sm[i], beta_sm[i], device_number) - wblinv_PV(pe[i].sm_age, mu[cur_index][i][1], eta_sm[i], beta_sm[i], device_number));
	  			device_number = (def.type[2] == "l")? 1:pe[i].device_num;
	  			t_tc.push_back(wblinv_PV(age_tc[i], mu[cur_index][i][2], eta_tc[i], beta_tc[i], device_number) - wblinv_PV(pe[i].tc_age, mu[cur_index][i][2], eta_tc[i], beta_tc[i], device_number));
	  			device_number = (def.type[3] == "l")? 1:pe[i].device_num;
	  			t_tddb.push_back(wblinv_PV(age_tddb[i], mu[cur_index][i][3], eta_tddb[i], beta_tddb[i], device_number) - wblinv_PV(pe[i].tddb_age, mu[cur_index][i][3], eta_tddb[i], beta_tddb[i], device_number));
				}
				else {
	  			t_em.push_back(INF);
	  			t_sm.push_back(INF);
	  			t_tc.push_back(INF);
	  			t_tddb.push_back(INF);
				}
      }
      for (int i = 0; i < pe.size(); i++){
				if (t_em[i] > INF) t_em[i] = INF;
				if (t_sm[i] > INF) t_sm[i] = INF;
				if (t_tc[i] > INF) t_tc[i] = INF;
				if (t_tddb[i] > INF) t_tddb[i] = INF;
			}

      int index_min;
      RVector<int> index;
      //index  0 em, 1 sm , 2 tc,  3 tddb
      index.push_back(min(t_em));
      index.push_back(min(t_sm));
      index.push_back(min(t_tc));
      index.push_back(min(t_tddb));
      RVector<double> a;
      a.push_back(t_em[index[0]]);
      a.push_back(t_sm[index[1]]);
      a.push_back(t_tc[index[2]]);
      a.push_back(t_tddb[index[3]]);
      int idx = min(a);
      index_min = index[idx];
      //update list and age
      s_list[index_min] = '0';
#ifdef DEBUG
			cout<<"a is: "<<a<<endl;
      cout<<"the current s list is: "<<s_list<<" input s list is: "<<survive_list<<" index min is: "<<index_min<<endl;
      cout<<"the fail time is em: "<<t_em<<" sm: "<<t_sm<<" tc: "<<t_tc<<" tddb: "<<t_tddb<<endl;
#endif
      double t = a[idx];
      for (int i = 0; i < pe.size(); i++){
				int device_number = (def.type[0] == "l")? 1:pe[i].device_num;
				pe[i].em_age = wblcdf_PV(wblinv_PV(pe[i].em_age,mu[cur_index][i][0], eta_em[i], beta_em[i], device_number)+t, mu[cur_index][i][0], eta_em[i], beta_em[i],device_number);
				device_number = (def.type[1] == "l")? 1:pe[i].device_num;
				pe[i].sm_age = wblcdf_PV(wblinv_PV(pe[i].sm_age,mu[cur_index][i][1], eta_sm[i], beta_sm[i], device_number)+t, mu[cur_index][i][1], eta_sm[i], beta_sm[i], device_number);
				device_number = (def.type[2] == "l")? 1:pe[i].device_num;
				pe[i].tc_age = wblcdf_PV(wblinv_PV(pe[i].tc_age,mu[cur_index][i][2], eta_tc[i], beta_tc[i], device_number)+t, mu[cur_index][i][2], eta_tc[i], beta_tc[i], device_number);
				device_number = (def.type[3] == "l")? 1:pe[i].device_num;
				pe[i].tddb_age = wblcdf_PV(wblinv_PV(pe[i].tddb_age,mu[cur_index][i][3], eta_tddb[i], beta_tddb[i], device_number)+t, mu[cur_index][i][3], eta_tddb[i], beta_tddb[i], device_number);
      }
      if (a[idx]>0){
				if (flag == 1){
					flag = 0;
					first_fail.push_back(a[idx]);
#ifdef XY_VER
					fail_order.push_back(find_order(t_em, t_sm, t_tc, t_tddb));				
#endif
				}					
				cur_time += a[idx];
				//cout<<"curr time: "<<cur_time<<endl;
			} 
    }
    //cout<<"the single trial fail time is: "<<cur_time<<endl;
    fail_time.push_back(cur_time);
  }
	for (int i = 0; i < pe.size(); i++){
		pe[i].em_age = init_em[i];
		pe[i].sm_age = init_sm[i];
		pe[i].tc_age = init_tc[i];
		pe[i].tddb_age = init_tddb[i];
	}
	fail_time.push_back(sum(first_fail)/(first_fail.size()*1.0));  
	return ;
}

/*===========================================================================*/
 double find_order (const RVector<double> &t_em, const RVector<double> &t_sm, const RVector<double> &t_tc, const RVector<double> &t_tddb)
{
	RVector<RVector<double> > core_age;
	RVector<double> core_fail; 
	core_age.resize(4);
	for (int i = 0; i < 4; i++){
		core_age[i].push_back(t_em[i]);
		core_age[i].push_back(t_sm[i]);
		core_age[i].push_back(t_tc[i]);
		core_age[i].push_back(t_tddb[i]);
		core_fail.push_back(core_age[i][min(core_age[i])]);
	}
	double order = 0;
	for (int i = 0; i < 4; i++){
		order += min(core_fail) * pow(10, i*1.0);
		core_fail[min(core_fail)] = INF;
	}	
	return order;
}
/*===========================================================================*/
int in_list(const string & cur_list, const RVector<string> & survive_list, int *cur_index)
{
  *cur_index = 0;
  for (int i = 0; i < survive_list.size(); i++){
    if (cur_list == survive_list[i]){
      *cur_index = i;
      return 1;
    }
  }
  return 0;
}
/*===========================================================================*/
//*quick sort algorithm
int Partition(int low, int high, RVector<double> &arr) 
{ 
  double pivot, high_vac, low_vac;
  pivot = arr[low];
  while(high > low)
    { 
      high_vac = arr[high];
      while(pivot < high_vac){
	  		if(high <= low) break;
	  		high--;
	  		high_vac = arr[high];
			}

      arr[low] = high_vac;
      low_vac = arr[low];
      while(pivot > low_vac){
	  		if(high <= low) break;
	  		low++;
	  		low_vac = arr[low];
			}
      arr[high] = low_vac;
    }
  arr[low] = pivot;
  return low;
}

void Quick_sort(int low, int high, RVector<double> &arr)
{
  int Piv_index;
  if(low<high){
  	Piv_index = Partition(low,high,arr);
   	Quick_sort(low,Piv_index-1,arr);
   	Quick_sort(Piv_index+1,high,arr);
  }
}
