// Copyright 2017 by Yun Xiang, Tam Chantem, and Robert Dick.
// All rights reserved.

/*Copyright 2010, Yun Xiang<xiangyun@umich.edu>.*/
#ifndef MTTF_H_
#define MTTF_H_

#include "RStd.h"
#include "RVector.h"
#include "Cont.h"
#include "Parse.h"
using namespace std;
using namespace rstd;
class PE;
class GLOBAL;

double sys_mttf(const string & rel_file);
int min(const RVector<double> & x);
int max(const RVector<double> & x);
double sum(const RVector<double> & x);
double new_age(double t, double &mu, double &sigma, double age);
double total_age(double em_age, double tc_age, double sm_age, double tddb_age);
void Monte_Carlo(RVector<PE> &pe, const RVector<string> & survive_list, int
	&list_index, RVector<double> &fail_time, const RVector<RVector<RVector<double> > > & mu_profile, GLOBAL def, RVector<double> &fail_order);

double find_order (const RVector<double> &t_em, const RVector<double> &t_sm, const RVector<double> &t_tc, const RVector<double> &t_tddb);
void print_ranking (const RVector<double> &fail_order);

int in_list(const string & cur_list, const RVector<string> & survive_list, int
	*cur_index);
void Quick_sort(int low,int high, RVector<double> &arr);
int Partition(int low,int high,RVector<double> &arr);
int compare (const void * a, const void * b);
#endif
